(* Angeles Ruiz Muoz ,ordenador: 903 *)



MODULE Cine;
FROM IO IMPORT WrStr,RdStr,WrLn,RdLn,WrChar,RdChar,RdCard,WrCard;
FROM Window IMPORT Clear;
FROM Cadenas IMPORT TCadena;
FROM LibCine IMPORT TCine,Crear,DefinirPelicula,Comprar,Cancelar,
                    ListarTodas,Destruir,GuardarCine,CargarCine;


VAR
  cine:TCine;
  opcion:CHAR;
  nomfich,nomcomprador,nompeli:TCadena;
  numbuta,numfila,numsala,primer,ultimo:CARDINAL;
  ok1,ok2:BOOLEAN;




  PROCEDURE Pausa();
  VAR
    car:CHAR;
  BEGIN
    WrLn;
    WrStr("Pulse ENTER para continuar. ");RdLn;
    car:=RdChar();
  END Pausa;



  PROCEDURE Menu():CHAR;
  VAR
    car:CHAR;
  BEGIN
    Clear;
    WrLn;WrLn;
    WrStr(" MENU: ");WrLn;WrLn;
    WrStr("   A.Definir pelicula.");WrLn;
    WrStr("   B.Comprar.");WrLn;
    WrStr("   C.Cancelar.");WrLn;
    WrStr("   D.Listar todas.");WrLn;
    WrStr("   E.Guardar cine.");WrLn;
    WrStr("   F.Cargar cine.");WrLn;
    WrStr("   G.Salir.");WrLn;
    WrStr(">>>>Inrtroduzca una opcin: ");RdLn;
    car:=RdChar();
    RETURN(car);
  END Menu;





(*****************  Programa principal  ************************)
BEGIN
  cine:=Crear();
  REPEAT
     opcion:=Menu();
     CASE CAP(opcion) OF

        "A":(* Leer por teclado el nmero de sala,nombre de la pelicula y
               capacidad de la sala y almacenar esta informacin en la estruc
               tura de datos *)

            Clear;
            WrStr(" DATOS DE LA SALA: ");WrLn;WrLn;
            WrStr("-Numero de la sala: ");
            numsala:=RdCard();
            WrStr("-Nombre de la pelicula: ");
            RdStr(nompeli);
            WrStr("-Numero de filas de la sala: ");
            numfila:=RdCard();
            WrStr("-Numero de asientos por fila: ");
            numbuta:=RdCard();
            DefinirPelicula(cine,numsala,nompeli,numfila,numbuta,ok1);
            IF NOT(ok1) THEN
                   WrStr("ERROR: La sala no existe.");
            END;
            Pausa();|



        "B":(* Pide los datos del comprador y le reserva asientos.*);
            Clear;
            WrStr("-Numero de sala: ");
            numsala:=RdCard();
            WrStr("-Nombre del comprador: ");
            RdStr(nomcomprador);
            WrStr("-Numero de fila: ");
            numfila:=RdCard();
            WrStr("-Primer asiento que se va a ocupar: ");
            primer:=RdCard();
            WrStr("-Ultimo asiento que se va a ocupar: ");
            ultimo:=RdCard();
            Comprar(cine,numsala,nomcomprador,numfila,primer,ultimo,ok1,ok2);
            IF NOT(ok1) THEN
                    WrStr("ERROR:La sala no existe.");WrLn;
            ELSE
                IF NOT(ok2) THEN
                     WrStr("ERROR:Los asientos no se pueden asignar.");WrLn;
                END;
            END;
            Pausa();|




        "C":(** Se eliminan todas las localidades que una persona ha reservado **)
            Clear;
            WrStr("-Nombre de la persona que cancela las localidades: ");
            RdStr(nomcomprador);
            WrStr("-Nmero de sala de la que va a hacer la anulacin: ");
            numsala:=RdCard();
            Cancelar(cine,numsala,nomcomprador,ok1,ok2);
            IF NOT(ok1) THEN
               WrStr("ERROR:La sala no existe.");WrLn;
            ELSE
               IF NOT(ok1) THEN
                   WrStr("ERROR: La persona no tiene ninguna reserva en esa sala.");WrLn;
               END;
            END;
            Pausa();|




        "D":(* Lista todas las localidades compradas para todas las salas *)
            Clear;
            ListarTodas(cine);
            Pausa();|



        "E":(* guarda los datos en un fichero**)
            Clear;
            WrStr("-Nombre del fichero donde se va a guardar la estructura: ");
            RdStr(nomfich);
            GuardarCine(cine,nomfich);
            WrStr("Se ha guardado correctamente.");
            Pausa();|


        "F":(* carga la informacion de un fichero en el Tad *)
            Clear;
            WrStr("-Nombre del fichero del que se van a recuperar los datos: ");
            RdStr(nomfich);
            CargarCine(cine,nomfich,ok1);
            IF ok1 THEN
               WrStr("Los datos se han cargado correctamente.");WrLn;
            ELSE
              WrStr("ERROR:El fichero no existe.");WrLn;
            END;
            Pausa();|



        "G":Clear;
            WrStr("-Nombre: Angeles Ruiz Muoz.");WrLn;
            WrStr("-Maquina: 903");WrLn;
            Destruir(cine);|
     END;
  UNTIL CAP(opcion)="G";
END Cine.


